/**
 * Hits3.java
 * anchor weight
 * jama:http://math.nist.gov/javanumerics/jama/
 **/

import java.io.*;
import java.util.*;

public class Hits3{
    public static void main(String[] args) throws Exception{
	int d = 50; // Py[W̋tNĂy[Wmax

	try{
	    Maps MAP = new Maps();
	    if(args.length!=0){
		MAP.query = Tools.Input(args[0]);
	    }else{
		System.out.print("query:");
		MAP.query = Tools.Input();
	    }

	    //@RootSet̎擾
	    System.out.println("\n*Make RootSet3*");
	    MAP.BaseSet = Googly.todo(MAP.query);
	    MAP.RootSetSize = MAP.BaseSet.size();

	    // BaseSet̎擾 && RootSetTopicTagsT
	    System.out.print("\n*Make BaseSet3*");
	    MAP = GetURLs3.todo(MAP);

	    /* // _3BaseSet_first.txt
	    PrintWriter P_MAP =
	        new PrintWriter(new BufferedWriter(new FileWriter("_3BaseSet_first.txt")));
	    P_MAP = Tools.Output(P_MAP,MAP,MAP.LHMap);
	    P_MAP.close();
	    */
	    MAP.BaseSetSize0 = MAP.BaseSet.size();
	    System.out.print("\nBaseSetSize3_0:"+MAP.BaseSetSize0);

	    // RootSetփNĂy[W̎擾
	    System.out.println("");
	    System.out.println("\n*Make BaseSet3(link:RootSet3)*");
	    MAP = Googly.todo2(MAP,d);
	    System.out.println("\nBaseSetSize3_1:"+MAP.BaseSet.size());

	    /* // _3DiffOya_linkBS.txt , _3BaseSet.txt
	    PrintWriter P_DiffOya =
		new PrintWriter(new BufferedWriter(new FileWriter("_3DiffOya_linkBS.txt")));
	    PrintWriter P_BaseSet =
	        new PrintWriter(new BufferedWriter(new FileWriter("_3BaseSet.txt")));

	    P_DiffOya = Tools.Output_DO(P_DiffOya,MAP.DiffOya);
	    P_BaseSet = Tools.Output(P_BaseSet,MAP.BaseSet);
	    P_DiffOya.close();
	    P_BaseSet.close();
	    */

	    // SearchTopicTags
	    MAP = GetURLs3.SearchTopicTags3(MAP);
	    PrintWriter P_TopicTags = 
		new PrintWriter(new BufferedWriter(new FileWriter("_3TopicTags.txt")));
	    P_TopicTags = Tools.Output(P_TopicTags,MAP.TopicTags);
	    P_TopicTags.close();

	    // TopicTagšvZ
	    ArrayList TopicTagsValue = new ArrayList();
	    TopicTagsValue = TopicTagValue2.todo(MAP);
	    /* // _3TTV.txt
	    PrintWriter P_TTV =
		new PrintWriter(new BufferedWriter(new FileWriter("_3TTV.txt")));
	    // Tools.Output(TopicTagsValue);
	    P_TTV = Tools.Output(P_TTV,TopicTagsValue);
	    P_TTV.close();
	    */
	    MAP.TopicTags = new ArrayList(); //@

	    // 񎟌z̍쐬
	    int size = MAP.BaseSet.size();
	    double[][] Link = new double[size][size];
	    Link = MakeArray2.todo(TopicTagsValue,MAP,size);

	    // authority̌vZ
	    double[] Authority = new double[size];
	    Authority = CalculateAuthority_Hub.todo(Link,size);

	    // hub̌vZ
	    double[] Hub = new double[size];
	    Hub = CalculateAuthority_Hub.todo2(Link,size,Authority);
	    // sort
	    SortMaps AuthMAP = new SortMaps();
	    SortMaps HubMAP = new SortMaps();
	    AuthMAP = Sort.todo(MAP,Authority,size);
	    HubMAP = Sort.todo(MAP,Hub,size);

	    // output
	    PrintWriter P_AuthMAP =
		new PrintWriter(new BufferedWriter(new FileWriter("_3AuthorityWeight.txt")));
	    PrintWriter P_HubMAP =
	       new PrintWriter(new BufferedWriter(new FileWriter("_3HubWeight.txt")));

	    P_AuthMAP = Tools.Output(P_AuthMAP,AuthMAP,size);
	    P_HubMAP = Tools.Output(P_HubMAP,HubMAP,size);
	    P_AuthMAP.close();
	    P_HubMAP.close();
	    System.out.print("\n3BaseSetSize0:"+MAP.BaseSetSize0);
	    System.out.println("3BaseSetSize:"+MAP.BaseSet.size());
	    System.out.println("<<<END<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<");
	}catch(Exception e){
	    System.out.println("Hits3 error:"+e);
	}
    }

}



